// MOD FILE FOR KKSV DSGE 

var y infl r m n d mu mu_b mu_u 
	p nm nm_b nm_u
	expp lagexpp expy lagexpy;

varexo emp;

parameters beta, h, alpha, eta, omega, nu, rr, x, rss, rdss, chi, kappa, gamma_b, gamma_u,
		   Rrule, Grule, rho, rhoinfl, rhoy, sigmamp;

load parameterfile;
beta	= 0.99;
h		= 0.65;
alpha	= 0.75;
eta		= 1.9;
omega	= 0.5;
nu		= 0.2;
rr		= 0.02;
x		= 0.0067;
rss		= 1/beta;
rdss	= rss*(1-rr) - x*(1-rr) + rr;
chi		= (1/(eta*rss))*((nu*((rss-1)/rss)^(-omega) + (1-nu)*((rss-rdss)/rss)^(-omega)*(rr-x*(1-rr)))/(nu*((rss-1)/rss)^(1-omega) + (1-nu)*((rss-rdss)/rss)^(1-omega))) - 1;
kappa	= (1-alpha)*(1-alpha*beta)/alpha;
gamma_b	= (nu*((rss-1)/rss)^(-omega))/(nu*((rss-1)/rss)^(-omega) + rr*(1-nu)*((rss-rdss)/rss)^(-omega));
gamma_u = (nu*((rss-1)/rss)^(-omega))/(nu*((rss-1)/rss)^(-omega) + (1-nu)*((rss-rdss)/rss)^(-omega));
set_param_value('Rrule',Rrule);
set_param_value('Grule',Grule);
set_param_value('rho',rho);
set_param_value('rhoinfl',rhoinfl);
set_param_value('rhoy',rhoy);
set_param_value('sigmamp',sigmamp);

model (linear);
// NON-POLICY BLOCK
y 	 	= (h/(1+h))*y(-1) + (1/(1+h))*y(+1) - ((1-h)/(1+h))*((r - infl(+1)));
m 	 	= ((1+chi*(1-h))/((1+chi)*(1-h)))*y - (h/((1+chi)*(1-h)))*y(-1) - eta*r;
infl 	= infl(-1) + kappa*((1/(1-h))*y - (h/(1-h))*y(-1)) + beta*(infl(+1) - infl);
n	 	= m + omega*((1+chi)*eta - 1/(rss-1))*r;
d	 	= m + omega*((1+chi)*eta - (rr-x*(1-rr))/(rss-rdss))*r;
mu	 	= m - m(-1) + infl;
mu_b 	= gamma_b*(n-n(-1)) + (1-gamma_b)*(d-d(-1)) + infl;
mu_u 	= gamma_u*(n-n(-1)) + (1-gamma_u)*(d-d(-1)) + infl;

// LEVELS
p	 	= infl + p(-1);
nm	 	= mu + nm(-1);
nm_b 	= mu_b + nm_b(-1);
nm_u 	= mu_u + nm_u(-1);

// MAKE EXPECTATIONS CONSISTENT WITH ZERO-RESTRICTIONS
expp 	= p(+1);
lagexpp = expp(-1);
expy	= y(+1);
lagexpy	= expy(-1);



// MONETARY POLICY
Rrule*r + (1-Rrule)*mu = Rrule*(rho*r(-1) + (1-rho)*(rhoinfl*infl + rhoy*((1-Grule)*y + Grule*(y-y(-1)))) + emp) + (1-Rrule)*(rho*mu(-1) + (1-rho)*(rhoinfl*infl + rhoy*((1-Grule)*y + Grule*(y-y(-1)))) - emp);
end;

shocks;
var emp = sigmamp^2;
end;

stoch_simul(order=1,irf=16,noprint,nodisplay,nograph,nomoments) lagexpy lagexpp r nm_b nm nm_u;