function [residual, g1, g2, g3] = kksvMPshocksDeterminacy_dynamic(y, x, params, steady_state, it_)
%
% Status : Computes dynamic model for Dynare
%
% Inputs :
%   y         [#dynamic variables by 1] double    vector of endogenous variables in the order stored
%                                                 in M_.lead_lag_incidence; see the Manual
%   x         [M_.exo_nbr by nperiods] double     matrix of exogenous variables (in declaration order)
%                                                 for all simulation periods
%   params    [M_.param_nbr by 1] double          vector of parameter values in declaration order
%   it_       scalar double                       time period for exogenous variables for which to evaluate the model
%
% Outputs:
%   residual  [M_.endo_nbr by 1] double    vector of residuals of the dynamic model equations in order of 
%                                          declaration of the equations
%   g1        [M_.endo_nbr by #dynamic variables] double    Jacobian matrix of the dynamic model equations;
%                                                           columns: equations in order of declaration
%                                                           rows: variables in order stored in M_.lead_lag_incidence
%   g2        [M_.endo_nbr by (#dynamic variables)^2] double   Hessian matrix of the dynamic model equations;
%                                                              columns: equations in order of declaration
%                                                              rows: variables in order stored in M_.lead_lag_incidence
%   g3        [M_.endo_nbr by (#dynamic variables)^3] double   Third order derivative matrix of the dynamic model equations;
%                                                              columns: equations in order of declaration
%                                                              rows: variables in order stored in M_.lead_lag_incidence
%
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(17, 1);
lhs =y(14);
rhs =params(2)/(1+params(2))*y(1)+1/(1+params(2))*y(31)-(1-params(2))/(1+params(2))*(y(16)-y(32));
residual(1)= lhs-rhs;
lhs =y(17);
rhs =y(14)*(1+(1-params(2))*params(11))/((1-params(2))*(1+params(11)))-y(1)*params(2)/((1-params(2))*(1+params(11)))-y(16)*params(4);
residual(2)= lhs-rhs;
lhs =y(15);
rhs =y(2)+params(12)*(y(14)*1/(1-params(2))-y(1)*params(2)/(1-params(2)))+params(1)*(y(32)-y(15));
residual(3)= lhs-rhs;
lhs =y(18);
rhs =y(17)+y(16)*params(5)*((1+params(11))*params(4)-1/(params(9)-1));
residual(4)= lhs-rhs;
lhs =y(19);
rhs =y(17)+y(16)*params(5)*((1+params(11))*params(4)-(params(7)-params(8)*(1-params(7)))/(params(9)-params(10)));
residual(5)= lhs-rhs;
lhs =y(20);
rhs =y(15)+y(17)-y(4);
residual(6)= lhs-rhs;
lhs =y(21);
rhs =y(15)+params(13)*(y(18)-y(5))+(1-params(13))*(y(19)-y(6));
residual(7)= lhs-rhs;
lhs =y(22);
rhs =y(15)+(y(18)-y(5))*params(14)+(y(19)-y(6))*(1-params(14));
residual(8)= lhs-rhs;
lhs =y(23);
rhs =y(15)+y(8);
residual(9)= lhs-rhs;
lhs =y(24);
rhs =y(20)+y(9);
residual(10)= lhs-rhs;
lhs =y(25);
rhs =y(21)+y(10);
residual(11)= lhs-rhs;
lhs =y(26);
rhs =y(22)+y(11);
residual(12)= lhs-rhs;
lhs =y(27);
rhs =y(33);
residual(13)= lhs-rhs;
lhs =y(28);
rhs =y(12);
residual(14)= lhs-rhs;
lhs =y(29);
rhs =y(31);
residual(15)= lhs-rhs;
lhs =y(30);
rhs =y(13);
residual(16)= lhs-rhs;
lhs =y(16)*params(15)+y(20)*(1-params(15));
rhs =params(15)*(params(17)*y(3)+(1-params(17))*(y(15)*params(18)+params(19)*(y(14)*(1-params(16))+params(16)*(y(14)-y(1))))+x(it_, 1))+(1-params(15))*((1-params(17))*(y(15)*params(18)+params(19)*(y(14)*(1-params(16))+params(16)*(y(14)-y(1))))+params(17)*y(7)-x(it_, 1));
residual(17)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(17, 34);

  %
  % Jacobian matrix
  %

  g1(1,1)=(-(params(2)/(1+params(2))));
  g1(1,14)=1;
  g1(1,31)=(-(1/(1+params(2))));
  g1(1,32)=(-((1-params(2))/(1+params(2))));
  g1(1,16)=(1-params(2))/(1+params(2));
  g1(2,1)=params(2)/((1-params(2))*(1+params(11)));
  g1(2,14)=(-((1+(1-params(2))*params(11))/((1-params(2))*(1+params(11)))));
  g1(2,16)=params(4);
  g1(2,17)=1;
  g1(3,1)=(-(params(12)*(-(params(2)/(1-params(2))))));
  g1(3,14)=(-(params(12)*1/(1-params(2))));
  g1(3,2)=(-1);
  g1(3,15)=1-(-params(1));
  g1(3,32)=(-params(1));
  g1(4,16)=(-(params(5)*((1+params(11))*params(4)-1/(params(9)-1))));
  g1(4,17)=(-1);
  g1(4,18)=1;
  g1(5,16)=(-(params(5)*((1+params(11))*params(4)-(params(7)-params(8)*(1-params(7)))/(params(9)-params(10)))));
  g1(5,17)=(-1);
  g1(5,19)=1;
  g1(6,15)=(-1);
  g1(6,4)=1;
  g1(6,17)=(-1);
  g1(6,20)=1;
  g1(7,15)=(-1);
  g1(7,5)=params(13);
  g1(7,18)=(-params(13));
  g1(7,6)=1-params(13);
  g1(7,19)=(-(1-params(13)));
  g1(7,21)=1;
  g1(8,15)=(-1);
  g1(8,5)=params(14);
  g1(8,18)=(-params(14));
  g1(8,6)=1-params(14);
  g1(8,19)=(-(1-params(14)));
  g1(8,22)=1;
  g1(9,15)=(-1);
  g1(9,8)=(-1);
  g1(9,23)=1;
  g1(10,20)=(-1);
  g1(10,9)=(-1);
  g1(10,24)=1;
  g1(11,21)=(-1);
  g1(11,10)=(-1);
  g1(11,25)=1;
  g1(12,22)=(-1);
  g1(12,11)=(-1);
  g1(12,26)=1;
  g1(13,33)=(-1);
  g1(13,27)=1;
  g1(14,12)=(-1);
  g1(14,28)=1;
  g1(15,31)=(-1);
  g1(15,29)=1;
  g1(16,13)=(-1);
  g1(16,30)=1;
  g1(17,1)=(-(params(15)*(1-params(17))*params(19)*(-params(16))+(1-params(15))*(1-params(17))*params(19)*(-params(16))));
  g1(17,14)=(-(params(15)*(1-params(17))*params(19)*(params(16)+1-params(16))+(1-params(15))*(1-params(17))*params(19)*(params(16)+1-params(16))));
  g1(17,15)=(-(params(15)*(1-params(17))*params(18)+(1-params(15))*(1-params(17))*params(18)));
  g1(17,3)=(-(params(15)*params(17)));
  g1(17,16)=params(15);
  g1(17,7)=(-((1-params(15))*params(17)));
  g1(17,20)=1-params(15);
  g1(17,34)=(-(params(15)-(1-params(15))));
end
if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],17,1156);
end
if nargout >= 4,
  %
  % Third order derivatives
  %

  g3 = sparse([],[],[],17,39304);
end
end
