%% COMPUTES THE RESIDUAL DISTANCE BETWEEN TWO SETS OF IRFS
function [irf_resid] = mp_irf_resid(big_theta,TR_IRF,Grule);

%% DECLARE DET CHECK AS GLOBAL
global gdet_ oo_

Rrule	= 0;
sigmamp = .00001 + (2 - .00001)/(1+exp(.2*big_theta(1,1)));
rho		= (-.99) + (0.99 - (-.99))/(1+exp(.2*big_theta(2,1)));
rhoinfl = (-10) + (1 - (-10))/(1+exp(.2*big_theta(3,1)));
rhoy   	= (-10) + (1 - (-10))/(1+exp(.2*big_theta(4,1)));
save parameterfile Rrule Grule rho rhoinfl rhoy sigmamp

%% CHECK DETERMINACY
kksvMPshocksDeterminacy

% PENALIZE IF INDETERMINATE
if gdet_ == 0;
	disp('Indeterminate');
	irf_resid = 1e12;
% IF DETERMINATE COMPUTE RESID
elseif gdet_ == 1;
	kksvMPshocks
	MONEY_IRF 			= [10*oo_.irfs.lagexpy_emp', 10*oo_.irfs.lagexpp_emp', 10*oo_.irfs.nm_emp', oo_.irfs.nm_b_emp', 10*oo_.irfs.r_emp'];
	[periods,variables] = size(MONEY_IRF);
	resid_vec 			= reshape(MONEY_IRF,periods*variables,1) - reshape(TR_IRF,periods*variables,1);
	irf_resid 	  		= resid_vec'*resid_vec;
end;

format short
disp([1e3*irf_resid rho rhoinfl rhoy sigmamp]);

