% Load data
load_data_monthly

clc
close all

Y = [l_gdp, l_gdp_defl, l_pcomm, l_dm4, l_mb, l_rucm4];

Y = Y(1:end,:); %1:end = 1967:Q1 - 2015:Q4 // 1:164 = 1967:Q1 - 2007:Q4 // 1:114 = 1967:Q1 - 1995:Q2

%% SET LAG LENGTH
vlag = 13;

%% ESTIMATE WITH CONSTANT BUT NO TIME TREND
iscon = 1;

%% NOW ESTIMATE
[Bcomp, cvec, Bpl_ev, VC_eps, Residmat] = ...
									estim(Y, vlag, iscon);
									
%% SET NUMBER OF IRF PERIODS (adds first period so 15 implies 16 periods will be computed)
IRhoriz = 51;

%% SET OPTIONS FOR CONFIDENCE BANDS (MONTE CARLO INTEGRATION OF CONFIDENCE BANDS, SEE KOOP AND KOROBILIS, 2010)
NMC    = 10000;							% NUMBER OF DRAWS FROM THE POSTERIOR DISTRIBUTION
CIperc = [0.05, 0.95];					% CHOOSE WHICH PERCENTILES TO PLOT
[IRpoint, IRup_2, IRup_1, IRlo_1, IRlo_2, IRmed] = confid_int(Bcomp,VC_eps,cvec,IRhoriz,NMC,Y,CIperc);