%% Structural VAR
clear
clc

% Load data
load_data

clc
close all

Y = [l_gdp, l_gdp_defl, l_pcomm, l_dm4, l_mb, l_rucm4];

Y = Y(1:end,:); %1:end = 1967:Q1 - 2015:Q4 // 1:164 = 1967:Q1 - 2007:Q4 // 1:114 = 1967:Q1 - 1995:Q2

%% SET LAG LENGTH
vlag = 5;

%% ESTIMATE WITH CONSTANT BUT NO TIME TREND
iscon = 1;

%% NOW ESTIMATE
[Bcomp, cvec, Bpl_ev, VC_eps, Residmat] = ...
									estim(Y, vlag, iscon);
									
%% SET HORIZONS FOR FEVD
var_decomp_horizons = [4; 8; 20];	

%% SET OPTIONS FOR CONFIDENCE BANDS (MONTE CARLO INTEGRATION OF CONFIDENCE BANDS, SEE KOOP AND KOROBILIS, 2010)
NMC    = 10000;							% NUMBER OF DRAWS FROM THE POSTERIOR DISTRIBUTION
CIperc = [0.05, 0.95];					% CHOOSE WHICH PERCENTILES TO REPORT												   
[VDpoint, VDup_2, VDup_1, VDlo_1, VDlo_2, VDmed] = confid_int_fevd(Bcomp,VC_eps,cvec,NMC,Y,CIperc,var_decomp_horizons);

%% TABLE 2
RealGDPvd = [VDpoint(:,4,1)';VDlo_2(:,4,1)';VDup_2(:,4,1)']*100
GDPDeflvd = [VDpoint(:,4,2)';VDlo_2(:,4,2)';VDup_2(:,4,2)']*100
CommodPvd = [VDpoint(:,4,3)';VDlo_2(:,4,3)';VDup_2(:,4,3)']*100
DivisM4vd = [VDpoint(:,4,4)';VDlo_2(:,4,4)';VDup_2(:,4,4)']*100
MonBasevd = [VDpoint(:,4,5)';VDlo_2(:,4,5)';VDup_2(:,4,5)']*100
DivM4UCvd = [VDpoint(:,4,6)';VDlo_2(:,4,6)';VDup_2(:,4,6)']*100