%% Structural VAR
clear

% Load data
load_data

Y = [l_gdp, l_gdp_defl, l_pcomm, l_dm4, l_mb, l_rucm4];

Y = Y(1:end,:); %1:end = 1967:Q1 - 2015:Q4 // 1:164 = 1967:Q1 - 2007:Q4 // 1:114 = 1967:Q1 - 1995:Q2

%% SET LAG LENGTH
vlag = 5;

%% ESTIMATE WITH CONSTANT BUT NO TIME TREND
iscon = 1;

%% NOW ESTIMATE
[Bcomp, cvec, Bpl_ev, VC_eps, Residmat] = ...
									estim(Y, vlag, iscon);
									
%% IDENTIFY POSITION OF MONETARY POLICY INDICATOR IN VAR
MPIpos = 4;

%% SET OPTIONS FOR CONFIDENCE BANDS (MONTE CARLO INTEGRATION OF VAR, SEE KOOP AND KOROBILIS, 2010)
NMC    = 10000;							% NUMBER OF DRAWS FROM THE POSTERIOR DISTRIBUTION
CIperc = [0.05, 0.95];					% CHOOSE WHICH PERCENTILES TO PRODUCE
[MPrulepoint, MPruleup_2, MPruleup_1, MPrulelo_1, MPrulelo_2, MPrulemed] = confid_int_mprule(Bcomp,VC_eps,cvec,MPIpos,NMC,Y,CIperc);

% TABLE 3
%SRrule_sub3 	= [MPrulelo_2(:,1), MPrulepoint(:,1), MPruleup_2(:,1)];
%LRrule_sub3 	= [MPrulelo_2(:,2), MPrulepoint(:,2), MPruleup_2(:,2)];
LRdiffrule_sub3 = [MPrulelo_2(:,3), MPrulepoint(:,3), MPruleup_2(:,3)];
sam19672015 	= LRdiffrule_sub3